import java.util.ArrayList;
import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

@Entity
public class Employee {
  @Id
  private int id;

  private String name;

  @ManyToOne(cascade = { CascadeType.REFRESH })
  private Employee manager;

  @OneToMany(mappedBy = "manager")
  private Collection<Employee> directs = new ArrayList<Employee>();

  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Collection<Employee> getDirects() {
    return directs;
  }

  public void addDirect(Employee employee) {
    if (!getDirects().contains(employee)) {
      getDirects().add(employee);
      if (employee.getManager() != null) {
        employee.getManager().getDirects().remove(employee);
      }
      employee.setManager(this);
    }
  }

  public Employee getManager() {
    return manager;
  }

  public void setManager(Employee manager) {
    this.manager = manager;
  }

}
